package org.w3.rdf2rdf

import org.scalatest.FunSuite
import org.scalatest.matchers.ShouldMatchers

class ConstructTest extends FunSuite with ShouldMatchers with RDF2RDFModule {

  test("some queries") {

    Construct("CONSTRUCT { ?s ?p ?o } WHERE { ?s ?p ?o }")

    evaluating {
      Construct("CONSTRUCT { ?s ?p ?o } WHERE { ?s ?p }")
    } should produce [com.hp.hpl.jena.query.QueryParseException]

    // weird but synctaticaly correct
    Construct("CONSTRUCT { ?s ?p ?o } WHERE { ?a ?b ?c }")

    evaluating {
      Construct("SELECT ?s ?p ?o WHERE { ?a ?b ?c }")
    } should produce [AssertionError]

  }

}
