package org.w3.rdf

import org.scalatest.FunSuite

trait RDFModelTest extends FunSuite with Model with Implicits {

  test("what's done cannot be undone... but it can be deconstructed") {
    val timbl = IRI("http://www.w3.org/People/Berners-Lee/card#i")
    val IRI(timblS) = timbl
    assert("http://www.w3.org/People/Berners-Lee/card#i" === timblS)
    val triple = Triple(timbl, timbl, timbl)
    val Triple(SubjectNode(NodeIRI(s)), PredicateIRI(p), ObjectNode(NodeIRI(o))) = triple
    assert(timbl === s)
    assert(timbl === p)
    assert(timbl === o)
    val triple2 = Triple(BNode("label"), timbl, PlainLiteral("42", Some(LangTag("fr"))))
    val Triple(SubjectNode(NodeBNode(BNode(label))), _, ObjectLiteral(PlainLiteral(answer, Some(LangTag(lang))))) = triple2
    assert("label" === label)
    assert("42" === answer)
    assert("fr" === lang)
  }

}
