package org.w3.rdf.rdfxml

import org.w3.rdf.{Model => RDFModel, Implicits => RDFImplicits, _}

import org.scalatest.FunSuite

class RDFXMLTestWithRDF extends RDFXMLTest with ConcreteModel with RDFImplicits

abstract class RDFXMLTest extends FunSuite with RDFXMLModule with RDFImplicits {

  val parser = new RDFXMLParser {  }

  test("default on http://www.rdfabout.com/demo/validator/") {

    val rdfxml = """
<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/">
  <rdf:Description rdf:about="http://www.rdfabout.com/">
    <dc:title>rdf:about: About Resource Description Framework</dc:title>
  </rdf:Description>
</rdf:RDF>
""" // "

    val (graph, _) = parser.toGraph(rdfxml)

    println(graph)

  }

  test("default on http://www.w3.org/RDF/Validator/") {

    val rdfxml = """<?xml version="1.0"?>
<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/">
  <rdf:Description rdf:about="http://www.w3.org/">
    <dc:title>World Wide Web Consortium</dc:title> 
  </rdf:Description>
</rdf:RDF>
""" // "

    val (graph, _) = parser.toGraph(rdfxml)

    println(graph)

  }

}
