package org.w3.util

import scala.collection.immutable._

class GraphAnalyzer[A](m:Map[A, Set[A]]) {

  def reaches (from:A, to:A) = {
    if (m.contains(from))
      new GraphAnalyzer[A](m + (from -> (m(from) + to)))
    else
      new GraphAnalyzer[A](m + (from -> Set(to)))
  }
  def pair (l:A, r:A) = {
    reaches(l, r).reaches(r, l)
  }
  def neededFor (need:Set[A], t:A, visited:Set[A]):Boolean = {
    if (!m.contains(t))
      error("unknown symbol: " + t)
    var ret:Boolean = false
    m(t).map((r) => {
      if (visited.contains(t)) return false
      if (need.contains(t)) return true
      ret |= neededFor(need, r, visited + t)
    })
    return ret
  }

}

object GraphAnalyzer {
  def apply[A]():GraphAnalyzer[A] = GraphAnalyzer() // Map[A, Set[A]]()
  // def apply[A](list:List[A]):GraphAnalyzer[A] = new GraphAnalyzer(list)
  // def apply[A](args:A*):GraphAnalyzer[A] = GraphAnalyzer(args.toList)
}

// object GraphAnalyzer {
// }
// //def createEmptyGraphAnalyzer () = GraphAnalyzer(Map[A, Set[A]]())

  // case class Reacher (b:Map[String, Map[String, Set[String]]]) {
  //   def reaches (from:String, to:String) = {
  //     if (b.contains(from)) {
  // 	if (b(from).contains(to)) {
  // 	  val back = b(from)(to) + from
  // 	  val fore = b(from) + (to -> back)
  // 	  val ret = Reacher(b + (from -> fore))
  // 	  println("duplicate path from " + from + " to " + to)
  // 	  // println("ret: " + ret)
  // 	  ret
  // 	} else {
  // 	  println(from + "->" + to + " + " + this)
  // 	  val back = Set[String](from)
  // 	  val fore = b(from) + (to -> back)
  // 	  val ret = Reacher(b + (from -> fore))
  // 	  println("ret: " + ret)
  // 	  ret
  // 	}
  //     } else {
  // 	val back = Set[String](from)
  // 	val fore = Map[String, Set[String]](to -> back)
  // 	val ret = Reacher(b + (from -> fore))
  // 	// println("ret: " + ret)
  // 	ret
  //     }
  //   }
  //   def pair (l:String, r:String) = {
  //     reaches(l, r).reaches(r, l)
  //   }
  //   override def toString = b.toString
  // }
  // def createEmptyReacher () = Reacher(Map[String, Map[String, Set[String]]]())

